local MENU = {
  {DAMAGE, RESISTANCE_LABEL, ARMOR}, -- Damage, Resistance, Armor
  {SPELL_STAT5_NAME, SPELL_STAT4_NAME, RESISTANCE_LABEL}, -- Spirit, Intellect, Resistance
  {SPELL_STAT3_NAME, SPELL_STAT1_NAME, SPELL_STAT2_NAME}, -- Stamina, Strenght, Agility
  {SPELL_STAT4_NAME, SPELL_STAT5_NAME, ARMOR}, -- Intellect, Spirit, Armor
}

for i = 1, #MENU do
  MENU[i][4] = table.concat(MENU[i], ", ")
end

local gf = GossipFrame

local g1 = GossipTitleButton1
local g2 = GossipTitleButton2
local g3 = GossipTitleButton3
local g4 = GossipTitleButton4

local function resize(btn)
  btn:SetHeight(btn:GetTextHeight()+2)
end

local i
g1:HookScript("OnClick", function() i = 1 end)
g2:HookScript("OnClick", function() i = 2 end)
g3:HookScript("OnClick", function() i = 3 end)
g4:HookScript("OnClick", function() i = 4 end)

local npcid, count
local function update()
  npcid = tonumber((UnitGUID("npc") or ""):sub(6, 10), 16)
  if npcid == 14822 then
    count = GetNumGossipOptions()
    if count > 1 then
      if count == 4 then
        g1:SetText(MENU[1][4])
        g2:SetText(MENU[2][4])
        g3:SetText(MENU[3][4])
        g4:SetText(MENU[4][4])
        resize(g1)
        resize(g2)
        resize(g3)
        resize(g4)
      elseif count == 3 and i then
        g1:SetText(MENU[i][1])
        g2:SetText(MENU[i][2])
        g3:SetText(MENU[i][3])
        resize(g1)
        resize(g2)
        resize(g3)
      end
    end
  end
end

hooksecurefunc("GossipFrameUpdate", update)
